<p align="center" >
  <strong>Customize is awesome flutter package to create beautiful UI.</strong>
  <br />
  <br />
  <a href="https://www.buymeacoffee.com/aniketkhote" target="_blank"><img width="150px" src="https://cdn.buymeacoffee.com/buttons/default-yellow.png" alt="Buy Me A Coffee" style="height: 51px !important;width: 217px !important;" ></a>
</p>

<br />

![Pub Version](https://img.shields.io/pub/v/customize?color=blue&style=the-badge)
![GitHub contributors](https://img.shields.io/github/contributors/Aniketkhote/customize?style=the-badge)
![GitHub Release Date](https://img.shields.io/github/release-date/Aniketkhote/customize?style=the-badge)
![GitHub Workflow Status](https://img.shields.io/github/workflow/status/Aniketkhote/customize/CI?style=the-badge)

Thanks to the introduction of [extension methods](https://dart.dev/guides/language/extension-methods) in Dart 2.7.0, `customize` makes it possible to build widget tree\`s more readable and efficient.

[`Customize`](https://pub.dev/packages/customize) is build as a tool to enhance your Flutter UI development experience and make code easier. It is highly inspired by Bootstrap and Tailwind CSS. 
It also provide lots of extension methods on String, List and Map.

## How to Use

```yaml
# add this line to your dependencies
  customize: ^0.1.1
```

```dart
import 'package:customize/customize.dart';
```

## Basic Flutter Example
```dart

 FxAlert(
  title: "alert title".toTitleCase(),
  message: "this is alert message".toSentenceCase(),
  icon: Icons.check,
  borderRadius: FxRadius.radius10,
).p12

```

## Basic Dart Example
```dart
 List mapList = [
    {'id': 1, 'name': 'Desk', 'price': 200},
    {'id': 2, 'name': 'Chair', 'price': 100},
    {'id': 3, 'name': 'Bookcase', 'price': 150},
  ];

  //Get only those object whose price is 150 & 200
  print(mapList.whereIn('price', [150,200]));

  [
    {id: 3, name: Bookcase, price: 150}, 
    {id: 1, name: Desk, price: 200}
  ]


  //Get only those object whose price is not 150 & 200
  print(mapList.whereNotIn('price', [150,200]));

  [
    {'id': 2, 'name': 'Chair', 'price': 100}
  ]

```

## Some other methods
    - Widgets
        + height box
        + width box
        + square box

    - String Methods
        + isMobileNumber
        + minLength()
        + maxLength()
        + range()
        + mask()
        + countBy()
        + toTitleCase()
        + toSentenceCase
        + toCapitalCase
    
    - List Methods
        + flatten
        + flattenMap
        + countBy()
        + groupBy
        + groupByOnMap()
        + pluck()
        + sorted()
        + sortBy()
        + diff()
        + chunk()
        + only()
        + notOnly()
        + whereIn()
        + whereNotIn()
        + whereBetween()
        + whereNotBetween()
        + containsInMap()
        + containsKeyInMap()
        + containsValueInMap()

    - Map Methods
        + isEmptyOrNull
        + isNotEmptyOrNull
        + getId




Read the full [API reference](https://pub.dev/documentation/customize/latest/).


## Contributing 
Customize is 100% free and open source. We encourage and support an active, healthy community that accepts contributions from the public – including you.

- Pick up any issue marked with ["good first - issue"](https://github.com/Aniketkhote/customize/issues?q=is%3Aopen+is%3Aissue+label%3A%22good+first+issue%22)
- Fix a bug
- Write and improve some documentation. Documentation is very critical to us. We would appreciate help in adding multiple languages to our docs.
- If you are a developer, feel free to check out the source and submit pull requests.
- Please don't forget to like, follow, and star our repo! Join our growing community to keep up to date with the latest GetWidget development.

**Please don't forget to Like, Follow, and Star our repo!**


Code and documentation Copyright 2021 [Aniket Khote](https://github.com/Aniketkhote)